// Code generated by SQLBoiler 4.14.2 (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package models

import (
	"context"
	"database/sql"
	"fmt"
	"reflect"
	"strconv"
	"strings"
	"sync"
	"time"

	"github.com/friendsofgo/errors"
	"github.com/volatiletech/null/v8"
	"github.com/volatiletech/sqlboiler/v4/boil"
	"github.com/volatiletech/sqlboiler/v4/queries"
	"github.com/volatiletech/sqlboiler/v4/queries/qm"
	"github.com/volatiletech/sqlboiler/v4/queries/qmhelper"
	"github.com/volatiletech/strmangle"
)

// SpendVehicle is an object representing the database table.
type SpendVehicle struct {
	ID        int64      `boil:"id" json:"id" toml:"id" yaml:"id"`
	Month     null.Int   `boil:"month" json:"month,omitempty" toml:"month" yaml:"month,omitempty"`
	Year      null.Int   `boil:"year" json:"year,omitempty" toml:"year" yaml:"year,omitempty"`
	Amount    null.Int64 `boil:"amount" json:"amount,omitempty" toml:"amount" yaml:"amount,omitempty"`
	CreatedAt time.Time  `boil:"created_at" json:"created_at" toml:"created_at" yaml:"created_at"`
	UpdatedAt time.Time  `boil:"updated_at" json:"updated_at" toml:"updated_at" yaml:"updated_at"`

	R *spendVehicleR `boil:"-" json:"-" toml:"-" yaml:"-"`
	L spendVehicleL  `boil:"-" json:"-" toml:"-" yaml:"-"`
}

var SpendVehicleColumns = struct {
	ID        string
	Month     string
	Year      string
	Amount    string
	CreatedAt string
	UpdatedAt string
}{
	ID:        "id",
	Month:     "month",
	Year:      "year",
	Amount:    "amount",
	CreatedAt: "created_at",
	UpdatedAt: "updated_at",
}

var SpendVehicleTableColumns = struct {
	ID        string
	Month     string
	Year      string
	Amount    string
	CreatedAt string
	UpdatedAt string
}{
	ID:        "spend_vehicle.id",
	Month:     "spend_vehicle.month",
	Year:      "spend_vehicle.year",
	Amount:    "spend_vehicle.amount",
	CreatedAt: "spend_vehicle.created_at",
	UpdatedAt: "spend_vehicle.updated_at",
}

// Generated where

var SpendVehicleWhere = struct {
	ID        whereHelperint64
	Month     whereHelpernull_Int
	Year      whereHelpernull_Int
	Amount    whereHelpernull_Int64
	CreatedAt whereHelpertime_Time
	UpdatedAt whereHelpertime_Time
}{
	ID:        whereHelperint64{field: "\"spend_vehicle\".\"id\""},
	Month:     whereHelpernull_Int{field: "\"spend_vehicle\".\"month\""},
	Year:      whereHelpernull_Int{field: "\"spend_vehicle\".\"year\""},
	Amount:    whereHelpernull_Int64{field: "\"spend_vehicle\".\"amount\""},
	CreatedAt: whereHelpertime_Time{field: "\"spend_vehicle\".\"created_at\""},
	UpdatedAt: whereHelpertime_Time{field: "\"spend_vehicle\".\"updated_at\""},
}

// SpendVehicleRels is where relationship names are stored.
var SpendVehicleRels = struct {
}{}

// spendVehicleR is where relationships are stored.
type spendVehicleR struct {
}

// NewStruct creates a new relationship struct
func (*spendVehicleR) NewStruct() *spendVehicleR {
	return &spendVehicleR{}
}

// spendVehicleL is where Load methods for each relationship are stored.
type spendVehicleL struct{}

var (
	spendVehicleAllColumns            = []string{"id", "month", "year", "amount", "created_at", "updated_at"}
	spendVehicleColumnsWithoutDefault = []string{}
	spendVehicleColumnsWithDefault    = []string{"id", "month", "year", "amount", "created_at", "updated_at"}
	spendVehiclePrimaryKeyColumns     = []string{"id"}
	spendVehicleGeneratedColumns      = []string{}
)

type (
	// SpendVehicleSlice is an alias for a slice of pointers to SpendVehicle.
	// This should almost always be used instead of []SpendVehicle.
	SpendVehicleSlice []*SpendVehicle
	// SpendVehicleHook is the signature for custom SpendVehicle hook methods
	SpendVehicleHook func(context.Context, boil.ContextExecutor, *SpendVehicle) error

	spendVehicleQuery struct {
		*queries.Query
	}
)

// Cache for insert, update and upsert
var (
	spendVehicleType                 = reflect.TypeOf(&SpendVehicle{})
	spendVehicleMapping              = queries.MakeStructMapping(spendVehicleType)
	spendVehiclePrimaryKeyMapping, _ = queries.BindMapping(spendVehicleType, spendVehicleMapping, spendVehiclePrimaryKeyColumns)
	spendVehicleInsertCacheMut       sync.RWMutex
	spendVehicleInsertCache          = make(map[string]insertCache)
	spendVehicleUpdateCacheMut       sync.RWMutex
	spendVehicleUpdateCache          = make(map[string]updateCache)
	spendVehicleUpsertCacheMut       sync.RWMutex
	spendVehicleUpsertCache          = make(map[string]insertCache)
)

var (
	// Force time package dependency for automated UpdatedAt/CreatedAt.
	_ = time.Second
	// Force qmhelper dependency for where clause generation (which doesn't
	// always happen)
	_ = qmhelper.Where
)

var spendVehicleAfterSelectHooks []SpendVehicleHook

var spendVehicleBeforeInsertHooks []SpendVehicleHook
var spendVehicleAfterInsertHooks []SpendVehicleHook

var spendVehicleBeforeUpdateHooks []SpendVehicleHook
var spendVehicleAfterUpdateHooks []SpendVehicleHook

var spendVehicleBeforeDeleteHooks []SpendVehicleHook
var spendVehicleAfterDeleteHooks []SpendVehicleHook

var spendVehicleBeforeUpsertHooks []SpendVehicleHook
var spendVehicleAfterUpsertHooks []SpendVehicleHook

// doAfterSelectHooks executes all "after Select" hooks.
func (o *SpendVehicle) doAfterSelectHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range spendVehicleAfterSelectHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeInsertHooks executes all "before insert" hooks.
func (o *SpendVehicle) doBeforeInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range spendVehicleBeforeInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterInsertHooks executes all "after Insert" hooks.
func (o *SpendVehicle) doAfterInsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range spendVehicleAfterInsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpdateHooks executes all "before Update" hooks.
func (o *SpendVehicle) doBeforeUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range spendVehicleBeforeUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpdateHooks executes all "after Update" hooks.
func (o *SpendVehicle) doAfterUpdateHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range spendVehicleAfterUpdateHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeDeleteHooks executes all "before Delete" hooks.
func (o *SpendVehicle) doBeforeDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range spendVehicleBeforeDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterDeleteHooks executes all "after Delete" hooks.
func (o *SpendVehicle) doAfterDeleteHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range spendVehicleAfterDeleteHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doBeforeUpsertHooks executes all "before Upsert" hooks.
func (o *SpendVehicle) doBeforeUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range spendVehicleBeforeUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// doAfterUpsertHooks executes all "after Upsert" hooks.
func (o *SpendVehicle) doAfterUpsertHooks(ctx context.Context, exec boil.ContextExecutor) (err error) {
	if boil.HooksAreSkipped(ctx) {
		return nil
	}

	for _, hook := range spendVehicleAfterUpsertHooks {
		if err := hook(ctx, exec, o); err != nil {
			return err
		}
	}

	return nil
}

// AddSpendVehicleHook registers your hook function for all future operations.
func AddSpendVehicleHook(hookPoint boil.HookPoint, spendVehicleHook SpendVehicleHook) {
	switch hookPoint {
	case boil.AfterSelectHook:
		spendVehicleAfterSelectHooks = append(spendVehicleAfterSelectHooks, spendVehicleHook)
	case boil.BeforeInsertHook:
		spendVehicleBeforeInsertHooks = append(spendVehicleBeforeInsertHooks, spendVehicleHook)
	case boil.AfterInsertHook:
		spendVehicleAfterInsertHooks = append(spendVehicleAfterInsertHooks, spendVehicleHook)
	case boil.BeforeUpdateHook:
		spendVehicleBeforeUpdateHooks = append(spendVehicleBeforeUpdateHooks, spendVehicleHook)
	case boil.AfterUpdateHook:
		spendVehicleAfterUpdateHooks = append(spendVehicleAfterUpdateHooks, spendVehicleHook)
	case boil.BeforeDeleteHook:
		spendVehicleBeforeDeleteHooks = append(spendVehicleBeforeDeleteHooks, spendVehicleHook)
	case boil.AfterDeleteHook:
		spendVehicleAfterDeleteHooks = append(spendVehicleAfterDeleteHooks, spendVehicleHook)
	case boil.BeforeUpsertHook:
		spendVehicleBeforeUpsertHooks = append(spendVehicleBeforeUpsertHooks, spendVehicleHook)
	case boil.AfterUpsertHook:
		spendVehicleAfterUpsertHooks = append(spendVehicleAfterUpsertHooks, spendVehicleHook)
	}
}

// One returns a single spendVehicle record from the query.
func (q spendVehicleQuery) One(ctx context.Context, exec boil.ContextExecutor) (*SpendVehicle, error) {
	o := &SpendVehicle{}

	queries.SetLimit(q.Query, 1)

	err := q.Bind(ctx, exec, o)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: failed to execute a one query for spend_vehicle")
	}

	if err := o.doAfterSelectHooks(ctx, exec); err != nil {
		return o, err
	}

	return o, nil
}

// All returns all SpendVehicle records from the query.
func (q spendVehicleQuery) All(ctx context.Context, exec boil.ContextExecutor) (SpendVehicleSlice, error) {
	var o []*SpendVehicle

	err := q.Bind(ctx, exec, &o)
	if err != nil {
		return nil, errors.Wrap(err, "models: failed to assign all query results to SpendVehicle slice")
	}

	if len(spendVehicleAfterSelectHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterSelectHooks(ctx, exec); err != nil {
				return o, err
			}
		}
	}

	return o, nil
}

// Count returns the count of all SpendVehicle records in the query.
func (q spendVehicleQuery) Count(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to count spend_vehicle rows")
	}

	return count, nil
}

// Exists checks if the row exists in the table.
func (q spendVehicleQuery) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	var count int64

	queries.SetSelect(q.Query, nil)
	queries.SetCount(q.Query)
	queries.SetLimit(q.Query, 1)

	err := q.Query.QueryRowContext(ctx, exec).Scan(&count)
	if err != nil {
		return false, errors.Wrap(err, "models: failed to check if spend_vehicle exists")
	}

	return count > 0, nil
}

// SpendVehicles retrieves all the records using an executor.
func SpendVehicles(mods ...qm.QueryMod) spendVehicleQuery {
	mods = append(mods, qm.From("\"spend_vehicle\""))
	q := NewQuery(mods...)
	if len(queries.GetSelect(q)) == 0 {
		queries.SetSelect(q, []string{"\"spend_vehicle\".*"})
	}

	return spendVehicleQuery{q}
}

// FindSpendVehicle retrieves a single record by ID with an executor.
// If selectCols is empty Find will return all columns.
func FindSpendVehicle(ctx context.Context, exec boil.ContextExecutor, iD int64, selectCols ...string) (*SpendVehicle, error) {
	spendVehicleObj := &SpendVehicle{}

	sel := "*"
	if len(selectCols) > 0 {
		sel = strings.Join(strmangle.IdentQuoteSlice(dialect.LQ, dialect.RQ, selectCols), ",")
	}
	query := fmt.Sprintf(
		"select %s from \"spend_vehicle\" where \"id\"=$1", sel,
	)

	q := queries.Raw(query, iD)

	err := q.Bind(ctx, exec, spendVehicleObj)
	if err != nil {
		if errors.Is(err, sql.ErrNoRows) {
			return nil, sql.ErrNoRows
		}
		return nil, errors.Wrap(err, "models: unable to select from spend_vehicle")
	}

	if err = spendVehicleObj.doAfterSelectHooks(ctx, exec); err != nil {
		return spendVehicleObj, err
	}

	return spendVehicleObj, nil
}

// Insert a single record using an executor.
// See boil.Columns.InsertColumnSet documentation to understand column list inference for inserts.
func (o *SpendVehicle) Insert(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) error {
	if o == nil {
		return errors.New("models: no spend_vehicle provided for insertion")
	}

	var err error
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		if o.UpdatedAt.IsZero() {
			o.UpdatedAt = currTime
		}
	}

	if err := o.doBeforeInsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(spendVehicleColumnsWithDefault, o)

	key := makeCacheKey(columns, nzDefaults)
	spendVehicleInsertCacheMut.RLock()
	cache, cached := spendVehicleInsertCache[key]
	spendVehicleInsertCacheMut.RUnlock()

	if !cached {
		wl, returnColumns := columns.InsertColumnSet(
			spendVehicleAllColumns,
			spendVehicleColumnsWithDefault,
			spendVehicleColumnsWithoutDefault,
			nzDefaults,
		)

		cache.valueMapping, err = queries.BindMapping(spendVehicleType, spendVehicleMapping, wl)
		if err != nil {
			return err
		}
		cache.retMapping, err = queries.BindMapping(spendVehicleType, spendVehicleMapping, returnColumns)
		if err != nil {
			return err
		}
		if len(wl) != 0 {
			cache.query = fmt.Sprintf("INSERT INTO \"spend_vehicle\" (\"%s\") %%sVALUES (%s)%%s", strings.Join(wl, "\",\""), strmangle.Placeholders(dialect.UseIndexPlaceholders, len(wl), 1, 1))
		} else {
			cache.query = "INSERT INTO \"spend_vehicle\" %sDEFAULT VALUES%s"
		}

		var queryOutput, queryReturning string

		if len(cache.retMapping) != 0 {
			queryReturning = fmt.Sprintf(" RETURNING \"%s\"", strings.Join(returnColumns, "\",\""))
		}

		cache.query = fmt.Sprintf(cache.query, queryOutput, queryReturning)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}

	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(queries.PtrsFromMapping(value, cache.retMapping)...)
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}

	if err != nil {
		return errors.Wrap(err, "models: unable to insert into spend_vehicle")
	}

	if !cached {
		spendVehicleInsertCacheMut.Lock()
		spendVehicleInsertCache[key] = cache
		spendVehicleInsertCacheMut.Unlock()
	}

	return o.doAfterInsertHooks(ctx, exec)
}

// Update uses an executor to update the SpendVehicle.
// See boil.Columns.UpdateColumnSet documentation to understand column list inference for updates.
// Update does not automatically update the record in case of default values. Use .Reload() to refresh the records.
func (o *SpendVehicle) Update(ctx context.Context, exec boil.ContextExecutor, columns boil.Columns) (int64, error) {
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		o.UpdatedAt = currTime
	}

	var err error
	if err = o.doBeforeUpdateHooks(ctx, exec); err != nil {
		return 0, err
	}
	key := makeCacheKey(columns, nil)
	spendVehicleUpdateCacheMut.RLock()
	cache, cached := spendVehicleUpdateCache[key]
	spendVehicleUpdateCacheMut.RUnlock()

	if !cached {
		wl := columns.UpdateColumnSet(
			spendVehicleAllColumns,
			spendVehiclePrimaryKeyColumns,
		)

		if !columns.IsWhitelist() {
			wl = strmangle.SetComplement(wl, []string{"created_at"})
		}
		if len(wl) == 0 {
			return 0, errors.New("models: unable to update spend_vehicle, could not build whitelist")
		}

		cache.query = fmt.Sprintf("UPDATE \"spend_vehicle\" SET %s WHERE %s",
			strmangle.SetParamNames("\"", "\"", 1, wl),
			strmangle.WhereClause("\"", "\"", len(wl)+1, spendVehiclePrimaryKeyColumns),
		)
		cache.valueMapping, err = queries.BindMapping(spendVehicleType, spendVehicleMapping, append(wl, spendVehiclePrimaryKeyColumns...))
		if err != nil {
			return 0, err
		}
	}

	values := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), cache.valueMapping)

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, values)
	}
	var result sql.Result
	result, err = exec.ExecContext(ctx, cache.query, values...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update spend_vehicle row")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by update for spend_vehicle")
	}

	if !cached {
		spendVehicleUpdateCacheMut.Lock()
		spendVehicleUpdateCache[key] = cache
		spendVehicleUpdateCacheMut.Unlock()
	}

	return rowsAff, o.doAfterUpdateHooks(ctx, exec)
}

// UpdateAll updates all rows with the specified column values.
func (q spendVehicleQuery) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	queries.SetUpdate(q.Query, cols)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all for spend_vehicle")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected for spend_vehicle")
	}

	return rowsAff, nil
}

// UpdateAll updates all rows with the specified column values, using an executor.
func (o SpendVehicleSlice) UpdateAll(ctx context.Context, exec boil.ContextExecutor, cols M) (int64, error) {
	ln := int64(len(o))
	if ln == 0 {
		return 0, nil
	}

	if len(cols) == 0 {
		return 0, errors.New("models: update all requires at least one column argument")
	}

	colNames := make([]string, len(cols))
	args := make([]interface{}, len(cols))

	i := 0
	for name, value := range cols {
		colNames[i] = name
		args[i] = value
		i++
	}

	// Append all of the primary key values for each column
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), spendVehiclePrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := fmt.Sprintf("UPDATE \"spend_vehicle\" SET %s WHERE %s",
		strmangle.SetParamNames("\"", "\"", 1, colNames),
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), len(colNames)+1, spendVehiclePrimaryKeyColumns, len(o)))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to update all in spendVehicle slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to retrieve rows affected all in update all spendVehicle")
	}
	return rowsAff, nil
}

// Upsert attempts an insert using an executor, and does an update or ignore on conflict.
// See boil.Columns documentation for how to properly use updateColumns and insertColumns.
func (o *SpendVehicle) Upsert(ctx context.Context, exec boil.ContextExecutor, updateOnConflict bool, conflictColumns []string, updateColumns, insertColumns boil.Columns) error {
	if o == nil {
		return errors.New("models: no spend_vehicle provided for upsert")
	}
	if !boil.TimestampsAreSkipped(ctx) {
		currTime := time.Now().In(boil.GetLocation())

		if o.CreatedAt.IsZero() {
			o.CreatedAt = currTime
		}
		o.UpdatedAt = currTime
	}

	if err := o.doBeforeUpsertHooks(ctx, exec); err != nil {
		return err
	}

	nzDefaults := queries.NonZeroDefaultSet(spendVehicleColumnsWithDefault, o)

	// Build cache key in-line uglily - mysql vs psql problems
	buf := strmangle.GetBuffer()
	if updateOnConflict {
		buf.WriteByte('t')
	} else {
		buf.WriteByte('f')
	}
	buf.WriteByte('.')
	for _, c := range conflictColumns {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(updateColumns.Kind))
	for _, c := range updateColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	buf.WriteString(strconv.Itoa(insertColumns.Kind))
	for _, c := range insertColumns.Cols {
		buf.WriteString(c)
	}
	buf.WriteByte('.')
	for _, c := range nzDefaults {
		buf.WriteString(c)
	}
	key := buf.String()
	strmangle.PutBuffer(buf)

	spendVehicleUpsertCacheMut.RLock()
	cache, cached := spendVehicleUpsertCache[key]
	spendVehicleUpsertCacheMut.RUnlock()

	var err error

	if !cached {
		insert, ret := insertColumns.InsertColumnSet(
			spendVehicleAllColumns,
			spendVehicleColumnsWithDefault,
			spendVehicleColumnsWithoutDefault,
			nzDefaults,
		)

		update := updateColumns.UpdateColumnSet(
			spendVehicleAllColumns,
			spendVehiclePrimaryKeyColumns,
		)

		if updateOnConflict && len(update) == 0 {
			return errors.New("models: unable to upsert spend_vehicle, could not build update column list")
		}

		conflict := conflictColumns
		if len(conflict) == 0 {
			conflict = make([]string, len(spendVehiclePrimaryKeyColumns))
			copy(conflict, spendVehiclePrimaryKeyColumns)
		}
		cache.query = buildUpsertQueryPostgres(dialect, "\"spend_vehicle\"", updateOnConflict, ret, update, conflict, insert)

		cache.valueMapping, err = queries.BindMapping(spendVehicleType, spendVehicleMapping, insert)
		if err != nil {
			return err
		}
		if len(ret) != 0 {
			cache.retMapping, err = queries.BindMapping(spendVehicleType, spendVehicleMapping, ret)
			if err != nil {
				return err
			}
		}
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	vals := queries.ValuesFromMapping(value, cache.valueMapping)
	var returns []interface{}
	if len(cache.retMapping) != 0 {
		returns = queries.PtrsFromMapping(value, cache.retMapping)
	}

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, cache.query)
		fmt.Fprintln(writer, vals)
	}
	if len(cache.retMapping) != 0 {
		err = exec.QueryRowContext(ctx, cache.query, vals...).Scan(returns...)
		if errors.Is(err, sql.ErrNoRows) {
			err = nil // Postgres doesn't return anything when there's no update
		}
	} else {
		_, err = exec.ExecContext(ctx, cache.query, vals...)
	}
	if err != nil {
		return errors.Wrap(err, "models: unable to upsert spend_vehicle")
	}

	if !cached {
		spendVehicleUpsertCacheMut.Lock()
		spendVehicleUpsertCache[key] = cache
		spendVehicleUpsertCacheMut.Unlock()
	}

	return o.doAfterUpsertHooks(ctx, exec)
}

// Delete deletes a single SpendVehicle record with an executor.
// Delete will match against the primary key column to find the record to delete.
func (o *SpendVehicle) Delete(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if o == nil {
		return 0, errors.New("models: no SpendVehicle provided for delete")
	}

	if err := o.doBeforeDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	args := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(o)), spendVehiclePrimaryKeyMapping)
	sql := "DELETE FROM \"spend_vehicle\" WHERE \"id\"=$1"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args...)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete from spend_vehicle")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by delete for spend_vehicle")
	}

	if err := o.doAfterDeleteHooks(ctx, exec); err != nil {
		return 0, err
	}

	return rowsAff, nil
}

// DeleteAll deletes all matching rows.
func (q spendVehicleQuery) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if q.Query == nil {
		return 0, errors.New("models: no spendVehicleQuery provided for delete all")
	}

	queries.SetDelete(q.Query)

	result, err := q.Query.ExecContext(ctx, exec)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from spend_vehicle")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for spend_vehicle")
	}

	return rowsAff, nil
}

// DeleteAll deletes all rows in the slice, using an executor.
func (o SpendVehicleSlice) DeleteAll(ctx context.Context, exec boil.ContextExecutor) (int64, error) {
	if len(o) == 0 {
		return 0, nil
	}

	if len(spendVehicleBeforeDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doBeforeDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	var args []interface{}
	for _, obj := range o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), spendVehiclePrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "DELETE FROM \"spend_vehicle\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, spendVehiclePrimaryKeyColumns, len(o))

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, args)
	}
	result, err := exec.ExecContext(ctx, sql, args...)
	if err != nil {
		return 0, errors.Wrap(err, "models: unable to delete all from spendVehicle slice")
	}

	rowsAff, err := result.RowsAffected()
	if err != nil {
		return 0, errors.Wrap(err, "models: failed to get rows affected by deleteall for spend_vehicle")
	}

	if len(spendVehicleAfterDeleteHooks) != 0 {
		for _, obj := range o {
			if err := obj.doAfterDeleteHooks(ctx, exec); err != nil {
				return 0, err
			}
		}
	}

	return rowsAff, nil
}

// Reload refetches the object from the database
// using the primary keys with an executor.
func (o *SpendVehicle) Reload(ctx context.Context, exec boil.ContextExecutor) error {
	ret, err := FindSpendVehicle(ctx, exec, o.ID)
	if err != nil {
		return err
	}

	*o = *ret
	return nil
}

// ReloadAll refetches every row with matching primary key column values
// and overwrites the original object slice with the newly updated slice.
func (o *SpendVehicleSlice) ReloadAll(ctx context.Context, exec boil.ContextExecutor) error {
	if o == nil || len(*o) == 0 {
		return nil
	}

	slice := SpendVehicleSlice{}
	var args []interface{}
	for _, obj := range *o {
		pkeyArgs := queries.ValuesFromMapping(reflect.Indirect(reflect.ValueOf(obj)), spendVehiclePrimaryKeyMapping)
		args = append(args, pkeyArgs...)
	}

	sql := "SELECT \"spend_vehicle\".* FROM \"spend_vehicle\" WHERE " +
		strmangle.WhereClauseRepeated(string(dialect.LQ), string(dialect.RQ), 1, spendVehiclePrimaryKeyColumns, len(*o))

	q := queries.Raw(sql, args...)

	err := q.Bind(ctx, exec, &slice)
	if err != nil {
		return errors.Wrap(err, "models: unable to reload all in SpendVehicleSlice")
	}

	*o = slice

	return nil
}

// SpendVehicleExists checks if the SpendVehicle row exists.
func SpendVehicleExists(ctx context.Context, exec boil.ContextExecutor, iD int64) (bool, error) {
	var exists bool
	sql := "select exists(select 1 from \"spend_vehicle\" where \"id\"=$1 limit 1)"

	if boil.IsDebug(ctx) {
		writer := boil.DebugWriterFrom(ctx)
		fmt.Fprintln(writer, sql)
		fmt.Fprintln(writer, iD)
	}
	row := exec.QueryRowContext(ctx, sql, iD)

	err := row.Scan(&exists)
	if err != nil {
		return false, errors.Wrap(err, "models: unable to check if spend_vehicle exists")
	}

	return exists, nil
}

// Exists checks if the SpendVehicle row exists.
func (o *SpendVehicle) Exists(ctx context.Context, exec boil.ContextExecutor) (bool, error) {
	return SpendVehicleExists(ctx, exec, o.ID)
}
